#include "mainwindow.h"
#include "ui_mainwindow.h"

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);
    ui->sendButton->setEnabled(false);
    ui->disconnectButton->setEnabled(false);
    ui->IPLineEdit->setText("192.168.3.4");
    ui->portLineEdit->setText("4001");
    tcpSocket = NULL;//使用前先清空
}

MainWindow::~MainWindow()
{
    delete tcpSocket;
    delete ui;
}

void MainWindow::sendMassage(){}

void MainWindow::readMassage()
{
    QByteArray data=tcpSocket->readAll();
    ui->clearLineEdit->setText(QString(data));
}

void MainWindow::displayError(QAbstractSocket::SocketError)
{
    QMessageBox::warning (this, tr("Warnning"), tcpSocket->errorString ());
    tcpSocket->close ();
    ui->connnectButton->setEnabled (true);
    ui->disconnectButton->setEnabled (false);
    ui->sendButton->setEnabled (false);
}

void MainWindow::on_sendButton_clicked()
{
    QString sendmessage;
    sendmessage = ui->sendLineEdit->text();
   /* if(sendmessage == NULL) return;
    QByteArray block;//暂时存储我们需要发送的数据
    QDataStream out(&block,QIODevice::WriteOnly);//TCP必须和数据流一起使用
    out.setVersion(QDataStream::Qt_5_7);//设置数据流的版本（服务器和主机版本一定相同）
    out << sendmessage;
    tcpSocket->write(block);*/
    QByteArray data;
    data.append(sendmessage);
    tcpSocket->write(data);
}

void MainWindow::on_clearButton_clicked()
{
    ui->clearLineEdit->clear();
}

void MainWindow::on_connnectButton_clicked()
{
    flag = false;
    if(tcpSocket) delete tcpSocket;//如果有指向其他空间直接删除
    tcpSocket = new QTcpSocket(this);//申请堆空间有TCP发送和接受操作
    tcpIp = ui->IPLineEdit->text();
    tcpPort = ui->portLineEdit->text();
    if(tcpIp==NULL||tcpPort==NULL)//判断IP和PORT是否为空
    {
        QMessageBox msgBox;
        msgBox.setText("IP or PORT is Empty");
        msgBox.exec();
        return;
    }
    tcpSocket->connectToHost(tcpIp,tcpPort.toInt());//连接主机
    connect(tcpSocket,SIGNAL(error(QAbstractSocket::SocketError)),this,
            SLOT(displayError(QAbstractSocket::SocketError)));//错误连接
    connect(tcpSocket,SIGNAL(connected()),this,
            SLOT(connectUpdata()));//更新连接之后按钮的使能
    connect(tcpSocket,SIGNAL(readyRead()),this,
            SLOT(readMassage()));//读取信息的连接
    ui->connnectButton->setEnabled (false);
    ui->disconnectButton->setEnabled (true);

}

void MainWindow::on_disconnectButton_clicked()
{
    tcpSocket->abort();
    delete tcpSocket;
    tcpSocket=NULL;
    disconnectUpdata();
}

void MainWindow::connectUpdata()
{
    if(!flag)
    {
        QMessageBox msgBox;
        msgBox.setText("TCP connect successful");
        msgBox.exec();
        ui->connnectButton->setEnabled(false);
        ui->sendButton->setEnabled(true);
        ui->disconnectButton->setEnabled(true);
        ui->IPLineEdit->setEnabled(false);
        ui->portLineEdit->setEnabled(false);
    }
    flag=true;
}

void MainWindow::disconnectUpdata()
{
    ui->connnectButton->setEnabled(true);
    ui->sendButton->setEnabled(false);
    ui->disconnectButton->setEnabled(false);
    ui->IPLineEdit->setEnabled(true);
    ui->portLineEdit->setEnabled(true);
}

